/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     REM = 258,
     ENTITY = 259,
     IS = 260,
     PORT = 261,
     GENERIC = 262,
     IN = 263,
     OUT = 264,
     INOUT = 265,
     MAP = 266,
     BIT = 267,
     BITVECT = 268,
     DOWNTO = 269,
     TO = 270,
     TYPE = 271,
     END = 272,
     ARCHITECTURE = 273,
     COMPONENT = 274,
     OF = 275,
     SIGNAL = 276,
     BEGN = 277,
     NOT = 278,
     WHEN = 279,
     WITH = 280,
     EXIT = 281,
     SELECT = 282,
     OTHERS = 283,
     PROCESS = 284,
     VARIABLE = 285,
     CONSTANT = 286,
     IF = 287,
     THEN = 288,
     ELSIF = 289,
     ELSE = 290,
     CASE = 291,
     FOR = 292,
     LOOP = 293,
     GENERATE = 294,
     AFTER = 295,
     AND = 296,
     OR = 297,
     XOR = 298,
     XNOR = 299,
     MOD = 300,
     UNIT = 301,
     LASTVALUE = 302,
     EVENT = 303,
     POSEDGE = 304,
     NEGEDGE = 305,
     STRING = 306,
     NAME = 307,
     RANGE = 308,
     NULLV = 309,
     CONVFUNC_2 = 310,
     BASED = 311,
     NATURAL = 312,
     ORL = 313,
     ANDL = 314,
     EQUAL = 315,
     NOTEQ = 316,
     LESSEQ = 317,
     BIGEQ = 318,
     NOTL = 319,
     UPLUS = 320,
     UMINUS = 321
   };
#endif
/* Tokens.  */
#define REM 258
#define ENTITY 259
#define IS 260
#define PORT 261
#define GENERIC 262
#define IN 263
#define OUT 264
#define INOUT 265
#define MAP 266
#define BIT 267
#define BITVECT 268
#define DOWNTO 269
#define TO 270
#define TYPE 271
#define END 272
#define ARCHITECTURE 273
#define COMPONENT 274
#define OF 275
#define SIGNAL 276
#define BEGN 277
#define NOT 278
#define WHEN 279
#define WITH 280
#define EXIT 281
#define SELECT 282
#define OTHERS 283
#define PROCESS 284
#define VARIABLE 285
#define CONSTANT 286
#define IF 287
#define THEN 288
#define ELSIF 289
#define ELSE 290
#define CASE 291
#define FOR 292
#define LOOP 293
#define GENERATE 294
#define AFTER 295
#define AND 296
#define OR 297
#define XOR 298
#define XNOR 299
#define MOD 300
#define UNIT 301
#define LASTVALUE 302
#define EVENT 303
#define POSEDGE 304
#define NEGEDGE 305
#define STRING 306
#define NAME 307
#define RANGE 308
#define NULLV 309
#define CONVFUNC_2 310
#define BASED 311
#define NATURAL 312
#define ORL 313
#define ANDL 314
#define EQUAL 315
#define NOTEQ 316
#define LESSEQ 317
#define BIGEQ 318
#define NOTL 319
#define UPLUS 320
#define UMINUS 321




/* Copy the first part of user declarations.  */
#line 24 "vhd2vl.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "def.h"

int yylex(void);
void yyerror(char *s);

int skipRem = 0;
int lineno=1;

sglist *io_list=NULL;
sglist *sig_list=NULL;
sglist *type_list=NULL;

/* need a stack of clock-edges because all edges are processed before all processes are processed.
 * Edges are processed in source file order, processes are processed in reverse source file order.
 * The original scheme of just one clkedge variable makes all clocked processes have the edge sensitivity 
 * of the last clocked process in the file.
 */
int clkedges[MAXEDGES];
int clkptr = 0;
int delay=1;
int dolist=1;
int np=1;
char wire[]="wire ";
char reg[]="reg ";
int dowith=0;
slist *slwith;

/* Indentation variables */
int indent=0;
slist *indents[MAXINDENT];

void slprint(slist *sl){
  if(sl){
    assert(sl != sl->slst);
    slprint(sl->slst);
    switch(sl->type){
    case 0 :
      assert(sl != sl->data.sl);
      slprint(sl->data.sl);
      break;
    case 1 : case 4 :
      printf("%s",sl->data.txt);
      break;
    case 2 :
      printf("%d",sl->data.val);
      break;
    case 3 :
      printf("%s",*(sl->data.ptxt));
      break;
    }
  }
}

void fslprint(FILE *fp,slist *sl){
  if(sl){
    assert(sl != sl->slst);
    fslprint(fp,sl->slst);
    switch(sl->type){
    case 0 :
      assert(sl != sl->data.sl);
      fslprint(fp,sl->data.sl);
      break;
    case 1 : case 4 :
      fprintf(fp,"%s",sl->data.txt);
      break;
    case 2 :
      fprintf(fp,"%d",sl->data.val);
      break;
    case 3 :
      fprintf(fp,"%s",*(sl->data.ptxt));
      break;
    }
  }
}

slist *copysl(slist *sl){
  if(sl){
    slist *newsl;
    newsl = (slist *)malloc(sizeof(slist));
    *newsl = *sl;
    if (sl->slst != NULL) {
      assert(sl != sl->slst);
      newsl->slst = copysl(sl->slst);
    }
    switch(sl->type){
    case 0 :
      if (sl->data.sl != NULL) {
        assert(sl != sl->data.sl);
        newsl->data.sl = copysl(sl->data.sl);
      }
      break;
    case 1 : case 4 :
      newsl->data.txt = (char *) malloc(strlen(sl->data.txt) + 1);
      strcpy(newsl->data.txt, sl->data.txt);
      break;
    }
    return newsl;
  }
  return NULL;
}

slist *addtxt(slist *sl, char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = (slist *)malloc(sizeof(slist));
  p->type = 1;
  p->slst = sl;
  p->data.txt = (char *) malloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addothers(slist *sl, char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = (slist *)malloc(sizeof(slist));
  p->type = 4;
  p->slst = sl;
  p->data.txt = (char *) malloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addptxt(slist *sl, char **s){
  slist *p;

  if(s == NULL)
    return sl;

  p = (slist *)malloc(sizeof(slist));
  p->type = 3;
  p->slst = sl;
  p->data.ptxt = s;

  return p;
}

slist *addval(slist *sl, int val){
  slist *p;

  p = (slist *)malloc(sizeof(slist));
  p->type = 2;
  p->slst = sl;
  p->data.val = val;

  return p;
}

slist *addsl(slist *sl, slist *sl2){
  slist *p;
  if(sl2 == NULL) return sl;
  p = (slist *)malloc(sizeof(slist));
  p->type = 0;
  p->slst = sl;
  p->data.sl = sl2;
  return p;
}

slist *addvec(slist *sl, char *s){
  sl=addval(sl,strlen(s));
  sl=addtxt(sl,"'b ");
  sl=addtxt(sl,s);
  return sl;
}

slist *addind(slist *sl){
  if(sl)
    sl=addsl(indents[indent],sl);
  return sl;
}

slist *addpar(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"] ");
  } else
    sl=addtxt(sl," ");
  return sl;
}

slist *addwrap(char *l,slist *sl,char *r){
slist *s;
  s=addtxt(NULL,l);
  s=addsl(s,sl);
  return addtxt(s,r);
}

sglist *lookup(sglist *sg,char *s){
  for(;;){
    if(sg == NULL || strcmp(sg->name,s)==0)
      return sg;
    sg=sg->next;
  }
}

char *bottom(slist *sl){
  while(sl->slst != NULL)
    sl=sl->slst;
  return sl->data.txt;
}

char *inout_string(int type)
{
  char *name=NULL;
  switch(type) {
    case 0: name="input"  ; break;
    case 1: name="output" ; break;
    case 2: name="inout"  ; break;
    default: break;
  }
  return name;
}

int prec(char op){
  switch(op){
  case 'o': /* others */
    return 9;
    break;
  case 't':case 'n':
    return 8;
    break;
  case '~':
    return 7;
    break;
  case 'p': case 'm':
    return 6;
    break;
  case '*': case '/': case '%':
    return 5;
    break;
  case '+': case '-':
    return 4;
    break;
  case '&':
    return 3;
    break;
  case '^':
    return 2;
    break;
  case '|':
    return 1;
    break;
   default:
    return 0;
    break;
  }
}

expdata *addexpr(expdata *expr1,char op,char* opstr,expdata *expr2){
slist *sl1,*sl2;
  if(expr1 == NULL)
    sl1=NULL;
  else if(expr1->op == 'c')
    sl1=addwrap("{",expr1->sl,"}");
  else if(prec(expr1->op) < prec(op))
    sl1=addwrap("(",expr1->sl,")");
  else
    sl1=expr1->sl;

  if(expr2->op == 'c')
    sl2=addwrap("{",expr2->sl,"}");
  else if(prec(expr2->op) < prec(op))
    sl2=addwrap("(",expr2->sl,")");
  else
    sl2=expr2->sl;

  if(expr1 == NULL)
    expr1=expr2;
  else
    free(expr2);

  expr1->op=op;
  sl1=addtxt(sl1,opstr);
  sl1=addsl(sl1,sl2);
  expr1->sl=sl1;
  return expr1;
}

void slTxtReplace(slist *sl, char *match, char *replace){
  if(sl){
    slTxtReplace(sl->slst, match, replace);
    switch(sl->type) {
    case 0 :
      slTxtReplace(sl->data.sl, match, replace);
      break;
    case 1 :
      if (strcmp(sl->data.txt, match) == 0) {
        sl->data.txt = replace;
      }
      break;
    case 3 :
      if (strcmp(*(sl->data.ptxt), match) == 0) {
        *(sl->data.ptxt) = replace;
      }
      break;
    }
  }
}

void fixothers(slist *size_expr, slist *sl) {
  if(sl) {
    fixothers(size_expr, sl->slst);
    switch(sl->type) {
    case 0 :
      fixothers(size_expr,sl->data.sl);
      break;
    case 4 : {
      /* found an (OTHERS => 'x') clause - change to type 0, and insert the
       * size_expr for the corresponding signal */
      slist *p;
      slist *size_copy = (slist *)malloc(sizeof(slist));
      size_copy = copysl(size_expr);
      p = addtxt(NULL, "1'b");
      p = addtxt(p, sl->data.txt);
      p = addwrap("{",p,"}");
      p = addsl(size_copy, p);
      p = addwrap("{",p,"}");
      sl->type=0;
      sl->slst=p;
      sl->data.sl=NULL;
      break;
    } /* case 4 */
    } /* switch */
  }
}

void findothers(slval *sgin,slist *sl){
  sglist *sg = NULL;
  int size = -1;
  int useExpr=0;
  if(sgin->val>0) {
    size=sgin->val;
  } else if (sgin->range != NULL) {
    if (sgin->range->vtype != tVRANGE) {
      size=1;
    } else if (sgin->range->sizeval > 0) {
      size=sgin->range->sizeval;
    } else if (sgin->range->size_expr != NULL) {
      useExpr = 1;
      fixothers(sgin->range->size_expr, sl);
    }
  } else {
    if((sg=lookup(io_list,sgin->sl->data.txt))==NULL) {
      sg=lookup(sig_list,sgin->sl->data.txt);
    }
    if(sg) {
      if(sg->range->vtype != tVRANGE) {
        size=1;
      } else {
        if (sg->range->sizeval > 0) {
          size = sg->range->sizeval;
        } else {
          assert (sg->range->size_expr != NULL);
          useExpr = 1;
          fixothers(sg->range->size_expr, sl);
        }
      }
    } else {
      /* lookup failed, there was no vrange or size value in sgin - so just punt, and assign size=1 */
      size=1;
    }  /* if(sg) */
  }
  if (!useExpr) {
    assert(size>0);
    /* use size */
    slist *p;
    p = addval(NULL,size);
    fixothers(p,sl);
  }
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 413 "vhd2vl.y"
{
  char * txt; /* String */
  int n;      /* Value */
  vrange *v;  /* Signal range */
  sglist *sg; /* Signal list */
  slist *sl;  /* String list */
  expdata *e; /* Expression structure */
  slval *ss;  /* Signal structure */
}
/* Line 187 of yacc.c.  */
#line 627 "vhd2vl.tab.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 640 "vhd2vl.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   969

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  82
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  47
/* YYNRULES -- Number of rules.  */
#define YYNRULES  149
/* YYNRULES -- Number of states.  */
#define YYNSTATES  586

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   321

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    69,    79,
      75,    76,    70,    67,    80,    68,     2,    71,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    78,    77,
      61,    58,    62,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    81,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    59,    60,    63,    64,    65,    66,    72,
      73,    74
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     9,    13,    17,    18,    20,    22,    25,
      26,    28,    29,    30,    44,    66,    74,    84,    91,    96,
     102,   110,   112,   114,   116,   118,   123,   125,   129,   131,
     135,   137,   139,   154,   155,   156,   157,   165,   176,   186,
     206,   231,   232,   233,   236,   241,   243,   253,   265,   280,
     301,   317,   340,   371,   406,   419,   436,   453,   454,   456,
     458,   462,   466,   472,   478,   483,   488,   489,   492,   497,
     503,   508,   510,   518,   529,   531,   541,   550,   563,   579,
     595,   606,   611,   616,   617,   625,   630,   639,   647,   649,
     653,   655,   657,   659,   663,   667,   673,   681,   682,   683,
     687,   690,   695,   697,   702,   705,   710,   715,   717,   722,
     724,   726,   728,   731,   738,   742,   745,   748,   752,   756,
     760,   764,   768,   771,   775,   779,   783,   787,   792,   799,
     806,   810,   812,   816,   820,   824,   827,   831,   835,   840,
     844,   849,   854,   856,   858,   860,   864,   868,   872,   876
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      83,     0,    -1,    84,    89,    84,    96,    84,    -1,    84,
      89,    84,    -1,    84,    96,    84,    -1,    -1,    85,    -1,
       3,    -1,     3,    85,    -1,    -1,     5,    -1,    -1,    -1,
       4,    52,     5,     6,    75,    84,    91,    76,    77,    84,
      17,   104,    77,    -1,     4,    52,     5,     7,   101,    75,
      84,    90,    76,    77,     6,   101,    75,    84,    91,    76,
      77,    84,    17,   104,    77,    -1,   102,    78,    93,    78,
      58,   125,    84,    -1,   102,    78,    93,    78,    58,   125,
      77,    84,    90,    -1,   102,    78,    93,    77,    84,    90,
      -1,   102,    78,    93,    84,    -1,   102,    78,    92,    93,
      84,    -1,   102,    78,    92,    93,    77,    84,    91,    -1,
       8,    -1,     9,    -1,    10,    -1,    12,    -1,    13,    75,
      94,    76,    -1,    52,    -1,   128,    95,   128,    -1,   128,
      -1,    52,    79,    53,    -1,    14,    -1,    15,    -1,    18,
      52,    20,    52,     5,    84,    99,    22,    97,   103,    17,
     104,    77,    98,    -1,    -1,    -1,    -1,    99,    21,   102,
      78,    93,    77,    84,    -1,    99,    31,    52,    78,    93,
      78,    58,   125,    77,    84,    -1,    99,    16,    52,     5,
      75,   102,    76,    77,    84,    -1,    99,    19,    52,    86,
      84,     6,   100,    75,    84,    91,    76,    77,    84,    17,
      19,   104,    77,   101,    84,    -1,    99,    19,    52,    84,
       7,   100,    75,    84,    90,    76,    77,     6,   100,    75,
      84,    91,    76,    77,    84,    17,    19,    77,   101,    84,
      -1,    -1,    -1,    52,    84,    -1,    52,    80,    84,   102,
      -1,    84,    -1,    84,   124,    61,    58,    84,    87,   117,
      88,   103,    -1,    84,    25,   125,    27,    84,   107,   124,
      61,    58,   108,   103,    -1,    84,    52,    78,    52,     6,
      11,    75,    97,   120,    84,    76,    77,    98,   103,    -1,
      84,    52,    78,    52,     7,    11,    75,    97,   122,    76,
      98,     6,    11,    75,    97,   120,    76,    77,    98,   103,
      -1,   105,    29,    75,   116,    76,   110,    22,    97,   111,
      17,    29,   104,    77,    98,   103,    -1,   105,    29,    75,
     116,    76,   110,    22,    97,    84,    32,   106,    33,   111,
      17,    32,    77,    17,    29,   104,    77,    98,   103,    -1,
     105,    29,    75,   116,    76,   110,    22,    97,    84,    32,
     126,    33,    97,   111,    98,    34,   106,    33,    97,   111,
      98,    17,    32,    77,    17,    29,   104,    77,    98,   103,
      -1,   105,    29,    75,   116,    76,   110,    22,    97,    84,
      32,   126,    33,    97,   111,    98,    35,    32,   106,    33,
      97,   111,    98,    17,    32,    77,    17,    32,    77,    17,
      29,   104,    77,    98,   103,    -1,   105,    32,   126,    39,
      97,   103,    98,    17,    39,   104,    77,   103,    -1,   105,
      37,   124,     8,   125,    15,   125,    39,    97,   103,    98,
      17,    39,   104,    77,   103,    -1,   105,    37,   124,     8,
     125,    14,   125,    39,    97,   103,    98,    17,    39,   104,
      77,   103,    -1,    -1,    52,    -1,    84,    -1,    84,    52,
      78,    -1,    75,   106,    76,    -1,    52,    79,    48,    41,
     126,    -1,   126,    41,    52,    79,    48,    -1,    49,    75,
      52,    76,    -1,    50,    75,    52,    76,    -1,    -1,   109,
      77,    -1,   109,    80,    84,   108,    -1,   125,   119,    24,
      28,    77,    -1,   125,   119,    24,   114,    -1,    84,    -1,
      84,    30,   102,    78,    93,    77,   110,    -1,    84,    30,
     102,    78,    93,    78,    58,   125,    77,   110,    -1,    84,
      -1,    84,   124,    78,    58,    87,   125,    77,    88,   111,
      -1,    84,   124,    87,    61,    58,   117,    88,   111,    -1,
      84,    32,   126,    33,    97,   111,    98,   112,    17,    32,
      77,   111,    -1,    84,    37,   124,     8,   125,    15,   125,
      38,    97,   111,    98,    17,    38,    77,   111,    -1,    84,
      37,   124,     8,   125,    14,   125,    38,    97,   111,    98,
      17,    38,    77,   111,    -1,    84,    36,   124,     5,    84,
     113,    17,    36,    77,   111,    -1,    84,    26,    77,   111,
      -1,    84,    54,    77,   111,    -1,    -1,    34,   126,    33,
      97,   111,    98,   112,    -1,    35,    97,   111,    98,    -1,
      24,   114,    58,    62,    97,   111,    98,   113,    -1,    24,
      28,    58,    62,    97,   111,    98,    -1,   115,    -1,   114,
      81,   115,    -1,    51,    -1,    52,    -1,   124,    -1,   124,
      80,   116,    -1,   125,   119,    77,    -1,   125,   119,    24,
     126,    77,    -1,   125,   119,    24,   126,    35,   118,   117,
      -1,    -1,    -1,    40,    57,    46,    -1,    84,   121,    -1,
      84,   121,    80,   120,    -1,   124,    -1,    52,    58,    62,
     124,    -1,    84,   123,    -1,    84,   123,    80,   122,    -1,
      52,    58,    62,   125,    -1,    52,    -1,    52,    75,    94,
      76,    -1,   124,    -1,    51,    -1,    57,    -1,    57,    56,
      -1,    75,    28,    58,    62,    51,    76,    -1,   125,    69,
     125,    -1,    68,   125,    -1,    67,   125,    -1,   125,    67,
     125,    -1,   125,    68,   125,    -1,   125,    70,   125,    -1,
     125,    71,   125,    -1,   125,    45,   125,    -1,    23,   125,
      -1,   125,    41,   125,    -1,   125,    42,   125,    -1,   125,
      43,   125,    -1,   125,    44,   125,    -1,    13,    75,   125,
      76,    -1,    55,    75,   125,    80,    57,    76,    -1,    55,
      75,   125,    80,    52,    76,    -1,    75,   125,    76,    -1,
     127,    -1,    75,   126,    76,    -1,   126,    41,   126,    -1,
     126,    42,   126,    -1,    23,   126,    -1,   125,    58,   125,
      -1,   125,    62,   125,    -1,   125,    62,    58,   125,    -1,
     125,    61,   125,    -1,   125,    61,    58,   125,    -1,   125,
      71,    58,   125,    -1,   124,    -1,    51,    -1,    57,    -1,
     128,    67,   128,    -1,   128,    68,   128,    -1,   128,    70,
     128,    -1,   128,    71,   128,    -1,    75,   128,    76,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   484,   484,   498,   506,   517,   518,   521,   522,   528,
     528,   531,   532,   536,   573,   614,   635,   657,   677,   698,
     728,   763,   764,   765,   768,   773,   774,   788,   828,   834,
     850,   851,   855,   866,   869,   872,   873,   899,   908,   970,
     977,   986,   987,   989,  1001,  1015,  1017,  1030,  1058,  1071,
    1087,  1107,  1144,  1191,  1240,  1256,  1286,  1310,  1311,  1314,
    1315,  1318,  1319,  1323,  1328,  1332,  1338,  1340,  1341,  1349,
    1368,  1389,  1390,  1410,  1434,  1436,  1450,  1469,  1482,  1504,
    1526,  1541,  1547,  1557,  1558,  1568,  1577,  1586,  1595,  1596,
    1603,  1604,  1607,  1608,  1616,  1632,  1636,  1649,  1652,  1653,
    1656,  1660,  1669,  1670,  1681,  1685,  1694,  1704,  1718,  1740,
    1748,  1755,  1764,  1789,  1796,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1828,  1839,
    1849,  1862,  1863,  1866,  1871,  1876,  1884,  1901,  1918,  1935,
    1952,  1969,  1988,  1996,  2003,  2013,  2016,  2019,  2022,  2025
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "REM", "ENTITY", "IS", "PORT", "GENERIC",
  "IN", "OUT", "INOUT", "MAP", "BIT", "BITVECT", "DOWNTO", "TO", "TYPE",
  "END", "ARCHITECTURE", "COMPONENT", "OF", "SIGNAL", "BEGN", "NOT",
  "WHEN", "WITH", "EXIT", "SELECT", "OTHERS", "PROCESS", "VARIABLE",
  "CONSTANT", "IF", "THEN", "ELSIF", "ELSE", "CASE", "FOR", "LOOP",
  "GENERATE", "AFTER", "AND", "OR", "XOR", "XNOR", "MOD", "UNIT",
  "LASTVALUE", "EVENT", "POSEDGE", "NEGEDGE", "STRING", "NAME", "RANGE",
  "NULLV", "CONVFUNC_2", "BASED", "NATURAL", "'='", "ORL", "ANDL", "'<'",
  "'>'", "EQUAL", "NOTEQ", "LESSEQ", "BIGEQ", "'+'", "'-'", "'&'", "'*'",
  "'/'", "NOTL", "UPLUS", "UMINUS", "'('", "')'", "';'", "':'", "'''",
  "','", "'|'", "$accept", "trad", "rem", "remlist", "opt_is", "norem",
  "yesrem", "entity", "genlist", "portlist", "dir", "type", "vec_range",
  "updown", "architecture", "doindent", "unindent", "a_decl", "nolist",
  "yeslist", "s_list", "a_body", "oname", "optname", "edge", "yeswith",
  "with_list", "with_item", "p_decl", "p_body", "elsepart", "cases",
  "wlist", "wvalue", "sign_list", "sigvalue", "nodelay", "delay",
  "map_list", "map_item", "generic_map_list", "generic_map_item", "signal",
  "expr", "exprc", "conf", "simple_expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    61,   313,
     314,    60,    62,   315,   316,   317,   318,    43,    45,    38,
      42,    47,   319,   320,   321,    40,    41,    59,    58,    39,
      44,   124
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    82,    83,    83,    83,    84,    84,    85,    85,    86,
      86,    87,    88,    89,    89,    90,    90,    90,    90,    91,
      91,    92,    92,    92,    93,    93,    93,    94,    94,    94,
      95,    95,    96,    97,    98,    99,    99,    99,    99,    99,
      99,   100,   101,   102,   102,   103,   103,   103,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   104,   104,   105,
     105,   106,   106,   106,   106,   106,   107,   108,   108,   108,
     109,   110,   110,   110,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   112,   112,   112,   113,   113,   114,   114,
     115,   115,   116,   116,   117,   117,   117,   118,   119,   119,
     120,   120,   121,   121,   122,   122,   123,   124,   124,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   126,   126,   126,   126,   126,   127,   127,   127,   127,
     127,   127,   128,   128,   128,   128,   128,   128,   128,   128
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     5,     3,     3,     0,     1,     1,     2,     0,
       1,     0,     0,    13,    21,     7,     9,     6,     4,     5,
       7,     1,     1,     1,     1,     4,     1,     3,     1,     3,
       1,     1,    14,     0,     0,     0,     7,    10,     9,    19,
      24,     0,     0,     2,     4,     1,     9,    11,    14,    20,
      15,    22,    30,    34,    12,    16,    16,     0,     1,     1,
       3,     3,     5,     5,     4,     4,     0,     2,     4,     5,
       4,     1,     7,    10,     1,     9,     8,    12,    15,    15,
      10,     4,     4,     0,     7,     4,     8,     7,     1,     3,
       1,     1,     1,     3,     3,     5,     7,     0,     0,     3,
       2,     4,     1,     4,     2,     4,     4,     1,     4,     1,
       1,     1,     2,     6,     3,     2,     2,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     4,     6,     6,
       3,     1,     3,     3,     3,     2,     3,     3,     4,     3,
       4,     4,     1,     1,     1,     3,     3,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     7,     0,     0,     6,     8,     1,     0,     0,     5,
       5,     0,     0,     3,     4,     0,     0,     5,     0,    42,
       0,     2,     5,     0,     5,     0,     5,    35,     5,     0,
       0,     0,     0,     5,    43,     0,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     5,    21,    22,    23,     0,
       0,     0,     0,     5,     0,     5,     0,    44,     0,    24,
       0,    26,     5,     0,     5,     0,    10,     0,     5,     0,
      59,     0,     0,     0,    57,     0,     5,    19,    42,     5,
       0,    18,     0,    41,     0,     0,     0,   107,     0,    57,
       0,     0,     0,     0,    58,     0,   143,   107,   144,     0,
       0,   142,    28,     0,     0,     0,     0,     0,     0,    41,
       5,     0,     0,   110,   107,     0,   111,     0,     0,     0,
     109,     0,     0,    60,     0,     0,     0,     0,     0,     0,
       0,   131,     0,     0,    13,     0,     0,    25,    30,    31,
       0,     0,     0,     0,     0,    20,     5,    17,     5,     0,
       5,     0,    36,     0,   122,     0,   112,   116,   115,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,    34,     0,    92,   122,   135,
       0,     0,     0,     0,     0,     0,    33,     0,     0,     0,
       0,    29,   149,   145,   146,   147,   148,    27,     0,     5,
      15,     5,     0,     5,     0,     0,     0,   130,    66,   123,
     124,   125,   126,   121,   117,   118,   114,   119,   120,   108,
       0,     0,    11,    32,     5,     0,   132,   136,     0,   139,
       0,   137,     0,     5,   133,   134,     0,     0,     0,     0,
      38,     0,     0,   127,     0,     0,     0,     0,     0,     0,
      71,     0,    93,   140,   138,   141,    34,     0,     0,     5,
       0,    16,     0,     0,     0,     0,     0,     0,    33,    33,
      12,    98,     0,    33,     0,     0,     0,    37,     5,     0,
       0,   129,   128,   113,     0,     5,     5,     5,     0,     0,
       0,     5,     0,    33,    33,     0,    41,     5,     0,     0,
       5,     0,     0,    46,     0,     0,    94,     0,    74,     0,
      57,     5,     5,    57,     0,     0,     5,     0,    98,   107,
     100,   102,     0,     0,   104,    34,    99,     0,     0,     0,
       0,     0,     0,     0,    11,     0,     0,    34,    34,     0,
       5,     0,    47,    67,     5,     0,     0,     5,     0,     0,
       5,     0,    97,    95,     5,     0,     5,     0,     0,   107,
       0,     0,     0,     0,     0,     5,     0,     0,    57,     5,
       0,     0,    14,     0,    57,     0,     0,     0,   101,    34,
       0,   105,     0,     0,    72,     0,    74,    81,     0,     0,
       0,     0,     0,     5,    33,     0,     5,     0,    82,    11,
       0,     0,    54,     0,     0,     0,     0,    68,     0,    90,
      91,    70,    88,   103,     5,   106,     0,    96,     0,     0,
       0,     0,     0,    61,     0,     5,   107,     0,     0,     0,
       0,    34,    57,    57,     0,    42,    69,     0,    48,    33,
       5,     0,    64,    65,     0,     0,    34,     0,     0,     0,
       0,     0,     0,    12,     5,     0,     0,     5,     5,    89,
       5,    73,    33,    62,     0,    83,    63,     0,     0,     0,
       0,     0,    12,     5,    50,     5,     5,     0,    39,     0,
       5,     0,     0,    33,     0,     0,     0,     0,    33,    33,
       5,    76,    56,    55,     0,     0,    34,     0,     0,     0,
       0,     5,     0,    33,    33,     5,     5,     5,    75,     0,
      34,    83,    57,    33,    33,     0,     0,    34,     0,     5,
       5,    80,    34,    34,    42,     5,     0,    33,     0,     5,
       5,    33,    85,     5,    34,    34,     0,     0,     5,    49,
       0,    34,    34,    34,     5,    77,    87,     0,     0,     0,
      40,     5,     0,    83,    34,    86,     0,     0,    51,     0,
      84,     0,     5,     5,     0,     0,    79,    78,     0,     0,
       0,     0,    57,     0,     0,     0,    34,     0,     5,     0,
      52,    57,     0,    34,     5,    53
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,   386,     4,    68,   249,   287,     9,    37,    29,
      49,    62,   100,   144,    10,   501,   223,    32,   108,    23,
      30,    71,    95,    72,   361,   246,   316,   317,   251,   309,
     484,   449,   411,   412,   176,   270,   383,   289,   300,   320,
     302,   324,   120,   129,   234,   131,   102
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -410
static const yytype_int16 yypact[] =
{
      24,    24,    56,    48,  -410,  -410,  -410,     6,    13,    24,
      24,   103,   149,   174,  -410,    66,   143,    24,   129,  -410,
     220,  -410,    24,   167,    24,   183,    24,  -410,    15,   184,
     172,   183,   258,    24,  -410,   191,   110,   205,   232,   261,
     265,   183,  -410,   273,   183,    24,  -410,  -410,  -410,    19,
     206,    19,   332,   298,   263,    24,   267,  -410,   326,  -410,
     282,  -410,    17,   353,    20,   286,  -410,   355,    24,    19,
      29,   348,   238,    19,   314,    52,    24,  -410,  -410,    24,
     309,  -410,   183,  -410,   366,   301,   575,    82,   318,   314,
     305,   589,   330,   307,  -410,   306,  -410,    27,  -410,   179,
     316,  -410,    55,   183,   320,   183,   575,   321,   324,  -410,
      24,   325,   575,  -410,   334,   335,   359,   575,   575,   145,
    -410,   644,    52,   370,   360,   340,   330,   589,   549,   893,
     297,  -410,   416,   371,  -410,   385,   108,  -410,  -410,  -410,
     179,   179,   179,   179,   179,  -410,    24,  -410,    44,   364,
      24,   367,  -410,   575,  -410,   575,  -410,  -410,  -410,   392,
     796,    24,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   376,   133,    24,  -410,   377,   375,  -410,  -410,
     760,    -1,   575,   319,   368,   501,  -410,   589,   589,   575,
     575,  -410,  -410,   151,   151,  -410,  -410,   138,   183,    24,
    -410,    24,   183,    24,   806,   650,   394,  -410,  -410,   698,
     496,   118,   433,   475,   187,   187,   187,  -410,  -410,  -410,
     448,   453,  -410,  -410,    24,   330,  -410,   708,   575,   708,
     575,   708,   575,    24,   139,   139,   251,   664,   389,   183,
    -410,   390,   183,  -410,   141,   418,   330,   395,   404,   575,
     437,   458,  -410,   708,   708,   708,  -410,   575,   575,    24,
     408,  -410,   409,   405,   411,   413,   420,   438,  -410,  -410,
    -410,   862,   183,  -410,   477,   849,   856,  -410,    24,   492,
     428,  -410,  -410,  -410,   449,    24,    24,    24,   451,    -3,
     439,    24,   467,  -410,  -410,   498,  -410,    24,   575,   464,
      24,   469,   443,  -410,   476,   589,  -410,    19,   622,   506,
     314,    24,    24,   314,   482,   509,    24,   160,   862,   -24,
     480,  -410,   485,   512,   491,  -410,  -410,     1,   221,   497,
     194,   330,   330,   502,   495,   546,   505,  -410,  -410,   508,
      24,   564,  -410,  -410,    24,   562,   525,    24,   513,   527,
      24,   585,  -410,  -410,    24,   534,    24,   521,   524,    62,
     115,   570,   111,   600,   605,    24,   560,   558,   314,    24,
     603,   604,  -410,   183,   314,   575,     9,   330,  -410,  -410,
     575,  -410,   614,   575,  -410,   575,   690,  -410,   577,   579,
     591,   569,     8,    24,  -410,   615,    24,   575,  -410,  -410,
     593,   572,  -410,   608,   613,   584,   576,  -410,   578,  -410,
    -410,   580,  -410,  -410,    24,   898,   587,  -410,   715,   589,
     597,   599,   624,  -410,   652,    24,   136,   654,   566,   575,
     575,  -410,   314,   314,   602,  -410,  -410,   255,  -410,  -410,
      24,   114,  -410,  -410,   589,   648,  -410,   633,    31,   667,
     575,   575,   729,  -410,    24,   619,   620,    24,    24,  -410,
      24,  -410,  -410,   139,   621,   289,  -410,   641,    35,   666,
     363,   816,  -410,    24,  -410,    24,    24,   686,  -410,   628,
      24,   693,   194,   691,   707,   674,   675,   651,  -410,  -410,
      24,  -410,  -410,  -410,   710,   661,  -410,   718,   706,   177,
     194,    24,   717,  -410,  -410,    24,    24,    24,  -410,   677,
    -410,   294,   314,  -410,  -410,   728,   310,  -410,   687,    24,
      24,  -410,  -410,  -410,  -410,    24,   589,  -410,   703,    24,
      24,  -410,  -410,    24,  -410,  -410,   746,   764,    24,  -410,
     231,  -410,  -410,  -410,    24,  -410,  -410,   654,   749,   750,
    -410,    24,   772,   294,  -410,  -410,   713,   714,  -410,   761,
    -410,   790,    24,    24,   731,   777,  -410,  -410,   793,   734,
     783,   797,   314,   781,   740,   742,  -410,   803,    24,   794,
    -410,   314,   747,  -410,    24,  -410
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -410,  -410,     0,   824,  -410,  -299,  -409,  -410,   -97,   -91,
    -410,   -44,   704,  -410,   819,   -41,  -208,  -410,  -105,   -75,
     -25,  -220,   -84,  -410,  -346,  -410,   459,  -410,  -339,  -117,
     280,   288,   396,   406,   617,  -353,  -410,   528,  -336,  -410,
     503,  -410,   369,   365,   -89,  -410,    -9
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -46
static const yytype_int16 yytable[] =
{
       3,    55,   130,   104,   151,   125,    38,    64,   147,    13,
      14,   378,   145,   256,   391,   384,    54,    21,     1,    57,
       1,   305,    25,     1,    27,    85,    31,     1,    34,    93,
     417,    59,    60,    44,   346,   367,   352,   408,   179,   181,
     187,   188,   187,   188,   473,    58,   -45,     1,   274,   395,
     188,   122,     7,    67,    86,    70,     6,   107,    11,   467,
     409,   410,    77,   490,    81,    12,     8,   303,    84,   138,
     139,    61,    18,    19,   306,   226,   103,   453,   353,   105,
      38,    87,   409,   410,   226,   162,   163,   164,   165,   166,
     136,   337,   338,   486,    76,    33,   342,    79,    80,   235,
     429,   461,   122,    96,    97,   241,   135,   238,    15,    98,
     152,   167,   168,   169,   170,   171,   437,   351,    46,    47,
      48,   199,   140,   141,   479,   142,   143,    99,   111,   370,
     371,   193,   194,   195,   196,   197,   498,   122,   127,   220,
     221,   390,   261,   159,   394,   233,   198,   462,   200,   402,
     202,   263,   395,   188,   515,   187,   188,   122,   111,   162,
     123,   208,   165,   166,   357,   358,   113,   359,   112,    16,
     115,   414,   116,   159,   222,   140,   141,    38,   142,   143,
     187,   188,   117,   118,   192,   167,   168,   169,   170,   171,
     360,   314,     8,   264,   438,    20,   113,   114,   265,   239,
     115,   240,   116,   242,    22,   140,   141,   111,   142,   143,
     514,   122,   117,   118,    38,   447,   327,   127,   395,   188,
     119,   142,   143,   454,   250,    24,   336,   285,   286,   339,
      96,   114,   291,    70,   474,    28,    98,   343,   465,   387,
     344,   362,    26,   357,   358,   113,   359,   290,   398,   115,
      36,   116,   311,   312,    99,   492,   493,   170,   171,   277,
      35,   117,   118,   328,   514,   257,   258,    90,    45,   360,
      91,   392,   187,   188,    39,    92,   424,    40,   295,    41,
      42,    50,   405,    63,   401,   299,   301,    70,   511,    43,
     406,   308,   162,   163,   164,   165,   166,   315,   354,   355,
     322,     1,   525,    66,    -9,   539,   409,   410,   446,   532,
      51,    70,    70,    52,   536,   537,    70,    53,   167,   168,
     169,   170,   171,   482,   483,    56,   546,   547,   526,   527,
     441,   558,   111,   551,   552,   553,   186,    65,   187,   188,
     373,    69,   112,    74,   375,    73,   561,   299,   455,   456,
     301,   395,   188,   425,   250,   463,   491,    75,   580,    78,
     458,    82,    83,   496,   585,    89,    94,   106,   578,    70,
     113,   114,   109,   508,   115,   584,   116,   228,   110,   124,
     126,   111,   114,   134,   517,   133,   117,   118,   521,   522,
     523,   112,   137,   499,   119,   146,   427,   149,   460,   150,
     153,   488,   534,   535,   162,   163,   164,   165,   166,   122,
     155,   516,   542,   543,    70,   156,   545,   175,   174,   113,
     114,   480,   173,   115,   189,   116,   230,   554,   528,   190,
     167,   168,   169,   170,   171,   117,   118,   540,   191,    88,
     250,   201,   203,   119,   101,   566,   567,   506,   507,   538,
     206,   121,   219,   224,    70,   225,   245,   477,   478,   247,
     299,   132,   519,   520,   248,   260,   262,   272,   101,   266,
     268,   148,   529,   530,   162,    70,    70,   154,   166,   269,
     273,   280,   157,   158,   160,   278,   279,   281,   574,   282,
     544,   101,   178,   180,   292,   177,   283,   582,   296,   284,
     167,   168,   169,   170,   171,   297,   310,   298,   304,   101,
     101,   101,   101,   101,   111,   313,   319,   307,   204,   325,
     205,   323,   326,   335,   112,    70,   341,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   162,   550,   164,
     165,   166,   167,   168,   169,   170,   171,   227,   229,   231,
     218,    70,   113,   114,   236,   237,   115,   340,   116,   232,
     347,   348,   111,   167,   168,   169,   170,   171,   117,   118,
     349,   350,   127,   366,   356,   368,   119,   159,    70,   365,
     450,   451,   369,   374,    70,   372,   376,   377,   111,   380,
     379,   382,   385,   253,   177,   254,   388,   255,   112,   389,
     113,   114,   111,   393,   115,   396,   116,   162,   163,   164,
     165,   166,   127,   397,   271,   267,   117,   118,   399,   400,
     403,   404,   275,   276,   128,   416,   113,   114,   111,   420,
     115,   421,   116,   167,   168,   169,   170,   171,   127,   422,
     113,   114,   117,   118,   115,   423,   116,   432,   329,   431,
     119,   430,   433,   435,   330,   436,   117,   118,   331,   332,
     434,   437,   439,   318,   128,   444,   113,   426,   321,   445,
     115,   161,   116,   442,   114,   443,   333,   334,   448,   457,
     464,   466,   117,   118,   469,   162,   163,   164,   165,   166,
     128,   162,   163,   164,   165,   166,   475,   476,   481,   485,
     363,   364,   487,   494,   495,   162,   163,   164,   165,   166,
     497,   167,   168,   169,   170,   171,   329,   167,   168,   169,
     170,   171,   419,   500,   502,   180,   331,   332,   505,   509,
     244,   167,   168,   169,   170,   171,   503,   504,   510,   513,
     318,   259,   114,   166,   333,   415,   413,   512,   271,   518,
     418,   164,   165,   166,   524,   334,   162,   163,   164,   165,
     166,   531,   428,   548,   533,   167,   168,   169,   170,   171,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     541,   549,   167,   168,   169,   170,   171,   556,   557,   559,
     562,   563,   440,   564,   452,   271,   167,   168,   169,   170,
     171,   162,   163,   164,   165,   166,   472,   565,   568,   569,
     570,   571,   572,   575,   573,   470,   471,   576,   182,   577,
     579,   183,   184,   581,   583,     5,   172,   167,   168,   169,
     170,   185,    17,   560,   407,   555,   207,   162,   163,   164,
     165,   166,   252,   459,   468,     0,   345,   162,   163,   164,
     165,   166,     0,   381,   489,     0,     0,   162,   163,   164,
     165,   166,     0,   167,   168,   169,   170,   171,     0,     0,
       0,     0,   207,   167,   168,   169,   170,   171,     0,     0,
       0,     0,   243,   167,   168,   169,   170,   171,   293,     0,
     162,   163,   164,   165,   166,   294,     0,   162,   163,   164,
     165,   166,   288,   162,   163,   164,   165,   166,     0,     0,
       0,     0,     0,     0,     0,     0,   167,   168,   169,   170,
     171,     0,     0,   167,   168,   169,   170,   171,     0,   167,
     168,   169,   170,   171,   162,   163,   164,   165,   166,   162,
     163,   164,   165,   166,     0,     0,     0,     0,     0,     0,
       0,   182,     0,     0,   183,   184,     0,     0,     0,     0,
     167,   168,   169,   170,   185,   167,   168,   169,   170,   171
};

static const yytype_int16 yycheck[] =
{
       0,    42,    91,    78,   109,    89,    31,    51,   105,     9,
      10,   347,   103,   233,   360,   354,    41,    17,     3,    44,
       3,    24,    22,     3,    24,    69,    26,     3,    28,    73,
     383,    12,    13,    33,    58,   334,    35,    28,   127,   128,
      41,    42,    41,    42,   453,    45,    17,     3,   256,    41,
      42,    75,     4,    53,    25,    55,     0,    82,    52,    28,
      51,    52,    62,   472,    64,    52,    18,   287,    68,    14,
      15,    52,     6,     7,    77,    76,    76,   430,    77,    79,
     105,    52,    51,    52,    76,    41,    42,    43,    44,    45,
      99,   311,   312,    58,    77,    80,   316,    77,    78,   188,
     399,   440,    75,    51,    52,   202,    79,   198,     5,    57,
     110,    67,    68,    69,    70,    71,    81,   325,     8,     9,
      10,    77,    67,    68,   460,    70,    71,    75,    13,   337,
     338,   140,   141,   142,   143,   144,   482,    75,    23,     6,
       7,    79,   239,    28,    33,   186,   146,    33,   148,   369,
     150,   242,    41,    42,   500,    41,    42,    75,    13,    41,
      78,   161,    44,    45,    49,    50,    51,    52,    23,    20,
      55,   379,    57,    28,   174,    67,    68,   202,    70,    71,
      41,    42,    67,    68,    76,    67,    68,    69,    70,    71,
      75,   296,    18,    52,   414,    52,    51,    52,    57,   199,
      55,   201,    57,   203,    75,    67,    68,    13,    70,    71,
      33,    75,    67,    68,   239,    79,   305,    23,    41,    42,
      75,    70,    71,   431,   224,     5,   310,   268,   269,   313,
      51,    52,   273,   233,   454,    52,    57,    77,   446,   356,
      80,   330,    75,    49,    50,    51,    52,   272,   365,    55,
      78,    57,   293,   294,    75,   475,   476,    70,    71,   259,
      76,    67,    68,   307,    33,    14,    15,    29,    77,    75,
      32,   360,    41,    42,    16,    37,   393,    19,   278,    21,
      22,    76,   373,    77,   368,   285,   286,   287,   496,    31,
     374,   291,    41,    42,    43,    44,    45,   297,    77,    78,
     300,     3,   510,     5,     6,   525,    51,    52,   425,   517,
      78,   311,   312,    52,   522,   523,   316,    52,    67,    68,
      69,    70,    71,    34,    35,    52,   534,   535,    34,    35,
     419,   551,    13,   541,   542,   543,    39,     5,    41,    42,
     340,    78,    23,    17,   344,    78,   554,   347,   432,   433,
     350,    41,    42,   394,   354,   444,   473,    75,   578,     6,
     435,    75,     7,   480,   584,    17,    52,    58,   576,   369,
      51,    52,     6,   490,    55,   583,    57,    58,    77,    61,
      75,    13,    52,    77,   501,    78,    67,    68,   505,   506,
     507,    23,    76,   482,    75,    75,   396,    76,   439,    75,
      75,    38,   519,   520,    41,    42,    43,    44,    45,    75,
      75,   500,   529,   530,   414,    56,   533,    77,    58,    51,
      52,   462,    52,    55,     8,    57,    58,   544,   512,    58,
      67,    68,    69,    70,    71,    67,    68,   526,    53,    70,
     440,    77,    75,    75,    75,   562,   563,   488,   489,   524,
      58,    86,    76,    76,   454,    80,    62,   457,   458,    11,
     460,    92,   503,   504,    11,    76,    76,    30,    99,    51,
      75,   106,   513,   514,    41,   475,   476,   112,    45,    75,
      22,    76,   117,   118,   119,    77,    77,    76,   572,    76,
     531,   122,   127,   128,    17,   126,    76,   581,     6,    61,
      67,    68,    69,    70,    71,    77,    39,    58,    57,   140,
     141,   142,   143,   144,    13,    17,    52,    78,   153,    76,
     155,    52,    46,    17,    23,   525,    17,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    41,   538,    43,
      44,    45,    67,    68,    69,    70,    71,   182,   183,   184,
     185,   551,    51,    52,   189,   190,    55,    75,    57,    58,
      80,    76,    13,    67,    68,    69,    70,    71,    67,    68,
      58,    80,    23,    78,    77,    29,    75,    28,   578,    77,
      14,    15,    77,    19,   584,    77,    24,    62,    13,    62,
      77,     6,    58,   228,   225,   230,    75,   232,    23,    75,
      51,    52,    13,    33,    55,     5,    57,    41,    42,    43,
      44,    45,    23,     8,   249,   246,    67,    68,    58,    61,
      17,    17,   257,   258,    75,    11,    51,    52,    13,    52,
      55,    52,    57,    67,    68,    69,    70,    71,    23,    48,
      51,    52,    67,    68,    55,    76,    57,    39,    26,    77,
      75,    58,    39,    77,    32,    77,    67,    68,    36,    37,
      76,    81,    75,   298,    75,    41,    51,    52,   299,    17,
      55,    27,    57,    76,    52,    76,    54,   308,    24,    77,
      32,    48,    67,    68,    17,    41,    42,    43,    44,    45,
      75,    41,    42,    43,    44,    45,    77,    77,    77,    58,
     331,   332,    36,    17,    76,    41,    42,    43,    44,    45,
      17,    67,    68,    69,    70,    71,    26,    67,    68,    69,
      70,    71,    32,    32,    17,   360,    36,    37,    77,    19,
      80,    67,    68,    69,    70,    71,    62,    62,    77,    33,
     375,    77,    52,    45,    54,   380,   377,    29,   383,    32,
     385,    43,    44,    45,    77,   386,    41,    42,    43,    44,
      45,    33,   397,    17,    77,    67,    68,    69,    70,    71,
      41,    42,    43,    44,    45,    67,    68,    69,    70,    71,
      77,    17,    67,    68,    69,    70,    71,    38,    38,    17,
      77,    77,    77,    32,   429,   430,    67,    68,    69,    70,
      71,    41,    42,    43,    44,    45,    77,    17,    77,    32,
      17,    77,    29,    32,    17,   450,   451,    77,    58,    77,
      17,    61,    62,    29,    77,     1,   122,    67,    68,    69,
      70,    71,    13,   553,   375,   547,    76,    41,    42,    43,
      44,    45,   225,   437,   448,    -1,   318,    41,    42,    43,
      44,    45,    -1,   350,    38,    -1,    -1,    41,    42,    43,
      44,    45,    -1,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    76,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    76,    67,    68,    69,    70,    71,    39,    -1,
      41,    42,    43,    44,    45,    39,    -1,    41,    42,    43,
      44,    45,    40,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    -1,    67,    68,    69,    70,    71,    -1,    67,
      68,    69,    70,    71,    41,    42,    43,    44,    45,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    -1,    61,    62,    -1,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    67,    68,    69,    70,    71
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    83,    84,    85,    85,     0,     4,    18,    89,
      96,    52,    52,    84,    84,     5,    20,    96,     6,     7,
      52,    84,    75,   101,     5,    84,    75,    84,    52,    91,
     102,    84,    99,    80,    84,    76,    78,    90,   102,    16,
      19,    21,    22,    31,    84,    77,     8,     9,    10,    92,
      76,    78,    52,    52,   102,    97,    52,   102,    84,    12,
      13,    52,    93,    77,    93,     5,     5,    84,    86,    78,
      84,   103,   105,    78,    17,    75,    77,    84,     6,    77,
      78,    84,    75,     7,    84,    93,    25,    52,   124,    17,
      29,    32,    37,    93,    52,   104,    51,    52,    57,    75,
      94,   124,   128,    84,   101,    84,    58,   102,   100,     6,
      77,    13,    23,    51,    52,    55,    57,    67,    68,    75,
     124,   125,    75,    78,    61,   104,    75,    23,    75,   125,
     126,   127,   124,    78,    77,    79,   128,    76,    14,    15,
      67,    68,    70,    71,    95,    91,    75,    90,   125,    76,
      75,   100,    84,    75,   125,    75,    56,   125,   125,    28,
     125,    27,    41,    42,    43,    44,    45,    67,    68,    69,
      70,    71,    94,    52,    58,    77,   116,   124,   125,   126,
     125,   126,    58,    61,    62,    71,    39,    41,    42,     8,
      58,    53,    76,   128,   128,   128,   128,   128,    84,    77,
      84,    77,    84,    75,   125,   125,    58,    76,    84,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,    76,
       6,     7,    84,    98,    76,    80,    76,   125,    58,   125,
      58,   125,    58,    97,   126,   126,   125,   125,    91,    84,
      84,    90,    84,    76,    80,    62,   107,    11,    11,    87,
      84,   110,   116,   125,   125,   125,   103,    14,    15,    77,
      76,    90,    76,    91,    52,    57,    51,   124,    75,    75,
     117,   125,    30,    22,    98,   125,   125,    84,    77,    77,
      76,    76,    76,    76,    61,    97,    97,    88,    40,   119,
     102,    97,    17,    39,    39,    84,     6,    77,    58,    84,
     120,    84,   122,   103,    57,    24,    77,    78,    84,   111,
      39,    97,    97,    17,   100,    84,   108,   109,   125,    52,
     121,   124,    84,    52,   123,    76,    46,   126,    93,    26,
      32,    36,    37,    54,   124,    17,   104,   103,   103,   104,
      75,    17,   103,    77,    80,   119,    58,    80,    76,    58,
      80,    98,    35,    77,    77,    78,    77,    49,    50,    52,
      75,   106,   126,   124,   124,    77,    78,    87,    29,    77,
      98,    98,    77,    84,    19,    84,    24,    62,   120,    77,
      62,   122,     6,   118,   110,    58,    84,   111,    75,    75,
      79,   106,   126,    33,    33,    41,     5,     8,   111,    58,
      61,   104,   103,    17,    17,    91,   104,   108,    28,    51,
      52,   114,   115,   124,    98,   125,    11,   117,   125,    32,
      52,    52,    48,    76,   111,    97,    52,    84,   125,    87,
      58,    77,    39,    39,    76,    77,    77,    81,   103,    75,
      77,   126,    76,    76,    41,    17,   111,    79,    24,   113,
      14,    15,   125,   117,    98,   104,   104,    77,   101,   115,
      97,   110,    33,   126,    32,    98,    48,    28,   114,    17,
     125,   125,    77,    88,   103,    77,    77,    84,    84,   120,
      97,    77,    34,    35,   112,    58,    58,    36,    38,    38,
      88,   111,   103,   103,    17,    76,   111,    17,   106,   126,
      32,    97,    17,    62,    62,    77,    97,    97,   111,    19,
      77,    98,    29,    33,    33,   106,   126,   111,    32,    97,
      97,   111,   111,   111,    77,    98,    34,    35,   104,    97,
      97,    33,    98,    77,   111,   111,    98,    98,   101,   103,
     126,    77,   111,   111,    97,   111,    98,    98,    17,    17,
      84,    98,    98,    98,   111,   113,    38,    38,   103,    17,
     112,    98,    77,    77,    32,    17,   111,   111,    77,    32,
      17,    77,    29,    17,   104,    32,    77,    77,    98,    17,
     103,    29,   104,    77,    98,   103
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 484 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl((yyvsp[(1) - (5)].sl),(yyvsp[(2) - (5)].sl));
          sl=addsl(sl,(yyvsp[(3) - (5)].sl));
          sl=addsl(sl,(yyvsp[(4) - (5)].sl));
          sl=addsl(sl,(yyvsp[(5) - (5)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 3:
#line 498 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl((yyvsp[(1) - (3)].sl),(yyvsp[(2) - (3)].sl));
          sl=addsl(sl,(yyvsp[(3) - (3)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 4:
#line 506 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl((yyvsp[(1) - (3)].sl),(yyvsp[(2) - (3)].sl));
          sl=addsl(sl,(yyvsp[(3) - (3)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 5:
#line 517 "vhd2vl.y"
    {(yyval.sl)=NULL; ;}
    break;

  case 6:
#line 518 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl); ;}
    break;

  case 7:
#line 521 "vhd2vl.y"
    {(yyval.sl)=addtxt(indents[indent],(yyvsp[(1) - (1)].txt));;}
    break;

  case 8:
#line 522 "vhd2vl.y"
    {
           slist *sl;
           sl=addtxt(indents[indent],(yyvsp[(1) - (2)].txt));
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 9:
#line 528 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 11:
#line 531 "vhd2vl.y"
    {skipRem = 1;;}
    break;

  case 12:
#line 532 "vhd2vl.y"
    {skipRem = 0;;}
    break;

  case 13:
#line 536 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[(2) - (13)].txt)); /* NAME */
              sl=addtxt(sl,"(\n");
              /* Add the signal list */
              p=io_list;
              for(;;){
                sl=addtxt(sl,p->name);
                p=p->next;
                if(p)
                  sl=addtxt(sl,",\n");
                else{
                  sl=addtxt(sl,"\n");
                  break;
                }
              }
              sl=addtxt(sl,");\n\n");
              sl=addsl(sl,(yyvsp[(6) - (13)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(7) - (13)].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addtxt(sl," ");
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                sl=addtxt(sl,";\n");
                p=p->next;
              } while(p!=NULL);
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[(10) - (13)].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            ;}
    break;

  case 14:
#line 573 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[(2) - (21)].txt)); /* NAME */
              sl=addtxt(sl,"(\n");
              /* Add the signal list */
              p=io_list;
              for(;;){
                sl=addtxt(sl,p->name);
                p=p->next;
                if(p)
                  sl=addtxt(sl,",\n");
                else{
                  sl=addtxt(sl,"\n");
                  break;
                }
              }
              sl=addtxt(sl,");\n\n");
              sl=addsl(sl,(yyvsp[(7) - (21)].sl));  /* rem */
              sl=addsl(sl,(yyvsp[(8) - (21)].sl));  /* genlist */
              sl=addsl(sl,(yyvsp[(14) - (21)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(15) - (21)].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addtxt(sl," ");
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                sl=addtxt(sl,";\n");
                p=p->next;
              } while(p!=NULL);
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[(18) - (21)].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            ;}
    break;

  case 15:
#line 614 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (7)].v)); /* type */
            p=(yyvsp[(1) - (7)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[(6) - (7)].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 16:
#line 635 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (9)].v)); /* type */
            p=(yyvsp[(1) - (9)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[(6) - (9)].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(8) - (9)].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 17:
#line 657 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (6)].v)); /* type */
            p=(yyvsp[(1) - (6)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(5) - (6)].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[(6) - (6)].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 18:
#line 677 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (4)].v)); /* type */
            p=(yyvsp[(1) - (4)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 19:
#line 698 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;

              if(dolist){
                sl=addtxt(NULL,inout_string((yyvsp[(3) - (5)].n)));
                sl=addpar(sl,(yyvsp[(4) - (5)].v));
                p=(yyvsp[(1) - (5)].sg);
                for(;;){
                  sl=addtxt(sl,p->name);
                  p=p->next;
                  if(p==NULL)
                    break;
                  sl=addtxt(sl,", ");
                }
                sl=addtxt(sl,";\n");
                (yyval.sl)=addsl(sl,(yyvsp[(5) - (5)].sl));
                io_list=p=(yyvsp[(1) - (5)].sg);
                for(;;){
                  p->type=wire;
                  p->range=(yyvsp[(4) - (5)].v);
                  if(p->next==NULL)
                    break;
                  p=p->next;
                }
              } else{
                free((yyvsp[(5) - (5)].sl));
                free((yyvsp[(4) - (5)].v));
              }
            ;}
    break;

  case 20:
#line 728 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;

              if(dolist){
                sl=addtxt(NULL,inout_string((yyvsp[(3) - (7)].n)));
                sl=addpar(sl,(yyvsp[(4) - (7)].v));
                p=(yyvsp[(1) - (7)].sg);
                for(;;){
                  sl=addtxt(sl,p->name);
                  p=p->next;
                  if(p==NULL)
                    break;
                  sl=addtxt(sl,", ");
                }
                sl=addtxt(sl,";\n");
                sl=addsl(sl,(yyvsp[(6) - (7)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
                p=(yyvsp[(1) - (7)].sg);
                for(;;){
                  p->type=wire;
                  p->range=(yyvsp[(4) - (7)].v);
                  if(p->next==NULL)
                    break;
                  p=p->next;
                }
                p->next=io_list;
                io_list=(yyvsp[(1) - (7)].sg);
              } else{
                free((yyvsp[(6) - (7)].sl));
                free((yyvsp[(4) - (7)].v));
              }
            ;}
    break;

  case 21:
#line 763 "vhd2vl.y"
    { (yyval.n)=0;;}
    break;

  case 22:
#line 764 "vhd2vl.y"
    { (yyval.n)=1; ;}
    break;

  case 23:
#line 765 "vhd2vl.y"
    { (yyval.n)=2; ;}
    break;

  case 24:
#line 768 "vhd2vl.y"
    {
                (yyval.v)=(vrange *) malloc(sizeof(vrange));
                (yyval.v)->vtype =tSCALAR;
		(yyval.v)->nlo = NULL;
              ;}
    break;

  case 25:
#line 773 "vhd2vl.y"
    {(yyval.v)=(yyvsp[(3) - (4)].v);;}
    break;

  case 26:
#line 774 "vhd2vl.y"
    {
              sglist *sg;

                sg=lookup(type_list,(yyvsp[(1) - (1)].txt));
                if(sg)
                  (yyval.v)=sg->range;
                else{
                  fprintf(stderr,"Undefined type '%s' on line %d\n",(yyvsp[(1) - (1)].txt),lineno);
                  YYABORT;
                }
              ;}
    break;

  case 27:
#line 788 "vhd2vl.y"
    {
              (yyval.v)=(vrange *) malloc(sizeof(vrange));
              (yyval.v)->vtype=tVRANGE;
              (yyval.v)->nhi=(yyvsp[(1) - (3)].e)->sl;
              (yyval.v)->nlo=(yyvsp[(3) - (3)].e)->sl;
              (yyval.v)->size_expr = NULL;
              (yyval.v)->sizeval = -1; /* undefined size */
              /* calculate the width of this vrange */
              if ((yyvsp[(1) - (3)].e)->op == 'n' && (yyvsp[(3) - (3)].e)->op == 'n') {
                if ((yyvsp[(2) - (3)].n)==-1) { /* (nhi:natural downto nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[(1) - (3)].e)->value - (yyvsp[(3) - (3)].e)->value + 1;
                } else {      /* (nhi:natural to     nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[(3) - (3)].e)->value - (yyvsp[(1) - (3)].e)->value + 1;
                }
              } else {
                /* make an expression to calculate the width of this vrange:
                 * create an expression that calculates: 
                 *   size expr = (simple_expr1) - (simple_expr2) + 1 
                 */
                expdata *size_expr1  = malloc(sizeof(expdata));
                expdata *size_expr2  = malloc(sizeof(expdata));
                expdata *diff12  = malloc(sizeof(expdata));
                expdata *plusone = malloc(sizeof(expdata));
                expdata *finalexpr = malloc(sizeof(expdata));
                size_expr1->sl = addwrap("(",(yyvsp[(1) - (3)].e)->sl,")");
                size_expr2->sl = addwrap("(",(yyvsp[(3) - (3)].e)->sl,")");
                plusone->op='t';
                plusone->sl=addtxt(NULL,"1");
                if ((yyvsp[(2) - (3)].n)==-1) {
                  /* (simple_expr1 downto simple_expr1) */
                  diff12 = addexpr(size_expr1,'-',"-",size_expr2);
                } else {
                  /* (simple_expr1   to   simple_expr1) */
                  diff12 = addexpr(size_expr2,'-',"-",size_expr1);
                }
                finalexpr = addexpr(diff12,'+',"+",plusone);
                finalexpr->sl = addwrap("(",finalexpr->sl,")");
                (yyval.v)->size_expr = finalexpr->sl;
              }
            ;}
    break;

  case 28:
#line 828 "vhd2vl.y"
    {
              (yyval.v)=(vrange *) malloc(sizeof(vrange));
              (yyval.v)->vtype=tSUBSCRIPT;
              (yyval.v)->nhi=NULL;
              (yyval.v)->nlo=(yyvsp[(1) - (1)].e)->sl;
          ;}
    break;

  case 29:
#line 834 "vhd2vl.y"
    {
              /* lookup NAME and copy its vrange */
              (yyval.v)=(vrange *) malloc(sizeof(vrange));  /* useless memory leak */
              sglist *sg = NULL;
              if((sg=lookup(io_list,(yyvsp[(1) - (3)].txt)))==NULL) {
                sg=lookup(sig_list,(yyvsp[(1) - (3)].txt));
              }
              if(sg) {
                (yyval.v) = sg->range;
              } else {
                fprintf(stderr,"Undefined range \"%s'range\" on line %d\n",(yyvsp[(1) - (3)].txt),lineno);
                YYABORT;
              }
          ;}
    break;

  case 30:
#line 850 "vhd2vl.y"
    {(yyval.n)=-1;;}
    break;

  case 31:
#line 851 "vhd2vl.y"
    {(yyval.n)=1;;}
    break;

  case 32:
#line 856 "vhd2vl.y"
    {
               slist *sl;

                 sl=addsl((yyvsp[(6) - (14)].sl),(yyvsp[(7) - (14)].sl));
                 sl=addtxt(sl,"\n");
                 (yyval.sl)=addsl(sl,(yyvsp[(10) - (14)].sl));
               ;}
    break;

  case 33:
#line 866 "vhd2vl.y"
    {indent= indent < MAXINDENT ? indent + 1 : indent;;}
    break;

  case 34:
#line 869 "vhd2vl.y"
    {indent= indent > 0 ? indent - 1 : indent;;}
    break;

  case 35:
#line 872 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 36:
#line 873 "vhd2vl.y"
    {
            sglist *sg;
            slist *sl;
            int size;

              if((yyvsp[(5) - (7)].v)->vtype==tSUBSCRIPT)
                size=1;
              else
                size=-1;
              sl=(yyvsp[(1) - (7)].sl);
              sg=(yyvsp[(3) - (7)].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[(5) - (7)].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[(5) - (7)].v));
                sl=addtxt(sl,sg->name);
                sl=addtxt(sl,";\n");
                if(sg->next == NULL)
                  break;
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[(3) - (7)].sg);
              (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
            ;}
    break;

  case 37:
#line 899 "vhd2vl.y"
    {
            slist * sl;
              sl=addtxt((yyvsp[(1) - (10)].sl),"parameter ");
              sl=addtxt(sl,(yyvsp[(3) - (10)].txt));
              sl=addtxt(sl," = ");
              sl=addsl(sl,(yyvsp[(8) - (10)].e)->sl);
              sl=addtxt(sl,";\n");
              (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
            ;}
    break;

  case 38:
#line 908 "vhd2vl.y"
    {
            slist * sl,*sl2;
            sglist *p;
            int n,k;
              n=0;
              sl=NULL;
              p=(yyvsp[(6) - (9)].sg);
              for(;;){
                sl=addtxt(sl,"  ");
                sl=addtxt(sl,p->name);
                sl=addtxt(sl," = ");
                sl=addval(sl,n++);
                p=p->next;
                if(p==NULL){
                  sl=addtxt(sl,";\n");
                  break;
                } else
                  sl=addtxt(sl,",\n");
              }
              n--;
              k=0;
              /* code to find bit number of the msb of n */
              if(n&0xff00){
                k|=8;
                n&=0xff00;
              }
              if(n&0xf0f0){
                k|=4;
                n&=0xf0f0;
              }
              if(n&0xcccc){
                k|=2;
                n&=0xcccc;
              }
              if(n&0xaaaa){
                k|=1;
                n&=0xaaaa;
              }
              sl2=addtxt(NULL,"parameter [");
              sl2=addval(sl2,k);
              sl2=addtxt(sl2,":0]\n");
              sl=addsl(sl2,sl);
              sl=addsl((yyvsp[(1) - (9)].sl),sl);
              (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl));
              p=(sglist *) malloc(sizeof(sglist));
              p->name=(yyvsp[(3) - (9)].txt);
              p->range=(vrange *) malloc(sizeof(vrange));
              p->range->nlo=addtxt(NULL,"0");
              if(k>0) {
                char *natval = (char *) malloc(99*sizeof(char));
                p->range->vtype = tVRANGE;
                p->range->sizeval = k+1;
                sprintf(natval, "%d",k);
                p->range->nhi=addtxt(NULL,natval);
              } else {
                p->range->vtype = tSCALAR;
                p->range->nhi= NULL;
              }
              p->next=type_list;
              type_list=p;
            ;}
    break;

  case 39:
#line 970 "vhd2vl.y"
    {
              (yyval.sl)=addsl((yyvsp[(1) - (19)].sl),(yyvsp[(19) - (19)].sl)); /* a_decl, rem4 */
              free((yyvsp[(3) - (19)].txt)); /* NAME */
              free((yyvsp[(9) - (19)].sl)); /* rem2 */
              free((yyvsp[(13) - (19)].sl));/* rem3 */
            ;}
    break;

  case 40:
#line 977 "vhd2vl.y"
    {
              (yyval.sl)=addsl((yyvsp[(1) - (24)].sl),(yyvsp[(24) - (24)].sl)); /* a_decl, rem5 */
              free((yyvsp[(3) - (24)].txt)); /* NAME */
              free((yyvsp[(8) - (24)].sl)); /* rem2 */
              free((yyvsp[(15) - (24)].sl));/* rem3 */
              free((yyvsp[(19) - (24)].sl));/* rem4 */
            ;}
    break;

  case 41:
#line 986 "vhd2vl.y"
    {dolist = 0;;}
    break;

  case 42:
#line 987 "vhd2vl.y"
    {dolist = 1;;}
    break;

  case 43:
#line 989 "vhd2vl.y"
    {
         sglist * sg;
           if(dolist){
             sg=(sglist *) malloc(sizeof(sglist));
             sg->name=(yyvsp[(1) - (2)].txt);
             sg->next=NULL;
             (yyval.sg)=sg;
           } else{
             free((yyvsp[(1) - (2)].txt));
             (yyval.sg)=NULL;
           }
         ;}
    break;

  case 44:
#line 1001 "vhd2vl.y"
    {
         sglist * sg;
           if(dolist){
             sg=(sglist *) malloc(sizeof(sglist));
             sg->name=(yyvsp[(1) - (4)].txt);
             sg->next=(yyvsp[(4) - (4)].sg);
             (yyval.sg)=sg;
           } else{
             free((yyvsp[(1) - (4)].txt));
             (yyval.sg)=NULL;
           }
         ;}
    break;

  case 45:
#line 1015 "vhd2vl.y"
    {(yyval.sl)=addind((yyvsp[(1) - (1)].sl));;}
    break;

  case 46:
#line 1017 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (9)].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[(2) - (9)].ss)->sl);
           findothers((yyvsp[(2) - (9)].ss),(yyvsp[(7) - (9)].sl));
           free((yyvsp[(2) - (9)].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(7) - (9)].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl));
         ;}
    break;

  case 47:
#line 1030 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg;
         char *s;
           sl=addsl((yyvsp[(1) - (11)].sl),indents[indent]);
           sl=addtxt(sl,"always @(*) begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  case(");
           sl=addsl(sl,(yyvsp[(3) - (11)].e)->sl);
           free((yyvsp[(3) - (11)].e));
           sl=addtxt(sl,")\n");
           if((yyvsp[(5) - (11)].sl))
             sl=addsl(sl,(yyvsp[(5) - (11)].sl));
           s=bottom((yyvsp[(7) - (11)].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           findothers((yyvsp[(7) - (11)].ss),(yyvsp[(10) - (11)].sl));
           free((yyvsp[(7) - (11)].ss));
           sl=addsl(sl,(yyvsp[(10) - (11)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  endcase\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(11) - (11)].sl));
         ;}
    break;

  case 48:
#line 1058 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (14)].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[(4) - (14)].txt)); /* NAME2 */
           sl=addtxt(sl," ");
           sl=addtxt(sl,(yyvsp[(2) - (14)].txt)); /* NAME1 */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(9) - (14)].sl));  /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(14) - (14)].sl)); /* a_body */
         ;}
    break;

  case 49:
#line 1071 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (20)].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[(4) - (20)].txt)); /* NAME2 (component name) */
           sl=addtxt(sl," #(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(9) - (20)].sl)); /* (generic) map_list */
           sl=addtxt(sl,")\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,(yyvsp[(2) - (20)].txt)); /* NAME1 (instance name) */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(16) - (20)].sl)); /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(20) - (20)].sl)); /* a_body */
         ;}
    break;

  case 50:
#line 1087 "vhd2vl.y"
    {
         slist *sl;
         char *s;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"always @(");
           sl=addsl(sl,(yyvsp[(4) - (15)].sl));
           sl=addtxt(sl,") begin");
           if((yyvsp[(6) - (15)].sl)){
             sl=addtxt(sl," : P");
             s=(char *) malloc(6*sizeof(char));
             sprintf(s,"%d\n",np++);
             sl=addtxt(sl,s);
             sl=addsl(sl,(yyvsp[(6) - (15)].sl));
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,(yyvsp[(9) - (15)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));
         ;}
    break;

  case 51:
#line 1109 "vhd2vl.y"
    {
           slist *sl;
           char *s;
           int clkedge;
             sl=addsl((yyvsp[(1) - (22)].sl),indents[indent]);
             sl=addtxt(sl,"always @(");
             clkedge = clkedges[--clkptr];
             if(clkedge) {
               sl=addtxt(sl,"posedge ");
               /* traverse $4->sl replacing " or " with " or posedge " if there is a clockedge */
               slTxtReplace((yyvsp[(4) - (22)].sl)," or ", " or posedge ");
             } else {
               sl=addtxt(sl,"negedge ");
               slTxtReplace((yyvsp[(4) - (22)].sl)," or ", " or negedge ");
             }
             sl=addsl(sl,(yyvsp[(4) - (22)].sl));
             sl=addtxt(sl,") begin");
             if((yyvsp[(6) - (22)].sl)){
               sl=addtxt(sl," : P");
               s=(char *) malloc(6*sizeof(char));
               sprintf(s,"%d\n",np++);
               sl=addtxt(sl,s);
               sl=addsl(sl,(yyvsp[(6) - (22)].sl));
             }
             sl=addtxt(sl,"\n");
             if((yyvsp[(9) - (22)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(9) - (22)].sl));
             }
             sl=addsl(sl,(yyvsp[(13) - (22)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(22) - (22)].sl));
         ;}
    break;

  case 52:
#line 1148 "vhd2vl.y"
    {
           slist *sl;
           char *s;
           int clkedge;
             sl=addsl((yyvsp[(1) - (30)].sl),indents[indent]);
             sl=addtxt(sl,"always @(");
             clkedge = clkedges[--clkptr];
             if(clkedge) {
               sl=addtxt(sl,"posedge ");
               slTxtReplace((yyvsp[(4) - (30)].sl)," or ", " or posedge ");
             } else {
               sl=addtxt(sl,"negedge ");
               slTxtReplace((yyvsp[(4) - (30)].sl)," or ", " or negedge ");
             }
             sl=addsl(sl,(yyvsp[(4) - (30)].sl));
             sl=addtxt(sl,") begin");
             if((yyvsp[(6) - (30)].sl)){
               sl=addtxt(sl," : P");
               s=(char *) malloc(6*sizeof(char));
               sprintf(s,"%d\n",np++);
               sl=addtxt(sl,s);
               sl=addsl(sl,(yyvsp[(6) - (30)].sl));
             }
             sl=addtxt(sl,"\n");
             if((yyvsp[(9) - (30)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(9) - (30)].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[(11) - (30)].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(14) - (30)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[(20) - (30)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(30) - (30)].sl));
         ;}
    break;

  case 53:
#line 1195 "vhd2vl.y"
    {
           slist *sl;
           char *s;
           int clkedge;
             sl=addsl((yyvsp[(1) - (34)].sl),indents[indent]);
             sl=addtxt(sl,"always @(");
             clkedge = clkedges[--clkptr];
             if(clkedge) {
               sl=addtxt(sl,"posedge ");
               slTxtReplace((yyvsp[(4) - (34)].sl)," or ", " or posedge ");
             } else {
               sl=addtxt(sl,"negedge ");
               slTxtReplace((yyvsp[(4) - (34)].sl)," or ", " or negedge ");
             }
             sl=addsl(sl,(yyvsp[(4) - (34)].sl));
             sl=addtxt(sl,") begin");
             if((yyvsp[(6) - (34)].sl)){
               sl=addtxt(sl," : P");
               s=(char *) malloc(6*sizeof(char));
               sprintf(s,"%d\n",np++);
               sl=addtxt(sl,s);
               sl=addsl(sl,(yyvsp[(6) - (34)].sl));
             }
             sl=addtxt(sl,"\n");
             if((yyvsp[(9) - (34)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(9) - (34)].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[(11) - (34)].sl)); /* exprc */
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(14) - (34)].sl)); /* p_body:1 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[(21) - (34)].sl)); /* p_body:2 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(34) - (34)].sl)); /* a_body */
         ;}
    break;

  case 54:
#line 1240 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (12)].sl),indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"if (");
           sl=addsl(sl,(yyvsp[(3) - (12)].sl)); /* exprc */
           sl=addtxt(sl,") begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(6) - (12)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(12) - (12)].sl));    /* a_body:2 */
         ;}
    break;

  case 55:
#line 1256 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (16)].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (16)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(7) - (16)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(10) - (16)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(16) - (16)].sl));    /* a_body:2 */
         ;}
    break;

  case 56:
#line 1286 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (16)].sl),indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (16)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[(7) - (16)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin\n");
           sl=addsl(sl,(yyvsp[(10) - (16)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(16) - (16)].sl));    /* a_body:2 */
         ;}
    break;

  case 57:
#line 1310 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 58:
#line 1311 "vhd2vl.y"
    {free((yyvsp[(1) - (1)].txt)); (yyval.sl)=NULL;;}
    break;

  case 59:
#line 1314 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 60:
#line 1315 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (3)].sl); free((yyvsp[(2) - (3)].txt));;}
    break;

  case 61:
#line 1318 "vhd2vl.y"
    {(yyval.sl)=addwrap("(",(yyvsp[(2) - (3)].sl),")");;}
    break;

  case 62:
#line 1319 "vhd2vl.y"
    {
         clkedges[clkptr++]=(yyvsp[(5) - (5)].sl)->data.sl->data.txt[0]-'0';
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 63:
#line 1323 "vhd2vl.y"
    {
         clkedges[clkptr++]=(yyvsp[(1) - (5)].sl)->data.sl->data.txt[0]-'0';
         clkptr++;
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 64:
#line 1328 "vhd2vl.y"
    {
         clkedges[clkptr++]=1;
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 65:
#line 1332 "vhd2vl.y"
    {
         clkedges[clkptr++]=0;
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 66:
#line 1338 "vhd2vl.y"
    {dowith=1;;}
    break;

  case 67:
#line 1340 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (2)].sl);;}
    break;

  case 68:
#line 1341 "vhd2vl.y"
    {
            slist *sl;
              if((yyvsp[(3) - (4)].sl)){
                sl=addsl((yyvsp[(1) - (4)].sl),(yyvsp[(3) - (4)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
              } else
                (yyval.sl)=addsl((yyvsp[(1) - (4)].sl),(yyvsp[(4) - (4)].sl));
            ;}
    break;

  case 69:
#line 1349 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt(indents[indent],"    default : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[(2) - (5)].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[(2) - (5)].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[(1) - (5)].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[(1) - (5)].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[(1) - (5)].e)->sl);
              free((yyvsp[(1) - (5)].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            ;}
    break;

  case 70:
#line 1368 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt(indents[indent],"    ");
              sl=addsl(sl,(yyvsp[(4) - (4)].sl));
              sl=addtxt(sl," : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[(2) - (4)].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[(2) - (4)].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[(1) - (4)].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[(1) - (4)].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[(1) - (4)].e)->sl);
              free((yyvsp[(1) - (4)].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            ;}
    break;

  case 71:
#line 1389 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 72:
#line 1390 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[(1) - (7)].sl),"    reg ");
           sl=addpar(sl,(yyvsp[(5) - (7)].v));
           free((yyvsp[(5) - (7)].v));
           sg=(yyvsp[(3) - (7)].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,",");
             else
               break;
           }
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
         ;}
    break;

  case 73:
#line 1410 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[(1) - (10)].sl),"    reg ");
           sl=addpar(sl,(yyvsp[(5) - (10)].v));
           free((yyvsp[(5) - (10)].v));
           sg=(yyvsp[(3) - (10)].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,",");
             else
               break;
           }
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(8) - (10)].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
         ;}
    break;

  case 74:
#line 1434 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 75:
#line 1436 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (9)].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[(2) - (9)].ss)->sl);
           findothers((yyvsp[(2) - (9)].ss),(yyvsp[(6) - (9)].e)->sl);
           sl=addtxt(sl," = ");
           if((yyvsp[(6) - (9)].e)->op == 'c')
             sl=addsl(sl,addwrap("{",(yyvsp[(6) - (9)].e)->sl,"}"));
           else
             sl=addsl(sl,(yyvsp[(6) - (9)].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl));
         ;}
    break;

  case 76:
#line 1450 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg;
         char *s;

           s=bottom((yyvsp[(2) - (8)].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           sl=addsl((yyvsp[(1) - (8)].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[(2) - (8)].ss)->sl);
           findothers((yyvsp[(2) - (8)].ss),(yyvsp[(6) - (8)].sl));
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(6) - (8)].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
         ;}
    break;

  case 77:
#line 1469 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (12)].sl),indents[indent]);
           sl=addtxt(sl,"if(");
           sl=addsl(sl,(yyvsp[(3) - (12)].sl));
           sl=addtxt(sl,") begin\n");
           sl=addsl(sl,(yyvsp[(6) - (12)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,(yyvsp[(8) - (12)].sl));
           (yyval.sl)=addsl(sl,(yyvsp[(12) - (12)].sl));
         ;}
    break;

  case 78:
#line 1482 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin \n");
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* p_body:2 */
         ;}
    break;

  case 79:
#line 1504 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin\n");
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* p_body:2 */
         ;}
    break;

  case 80:
#line 1526 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (10)].sl),indents[indent]);
           sl=addtxt(sl,"case(");
           sl=addsl(sl,(yyvsp[(3) - (10)].ss)->sl); /* signal */
           sl=addtxt(sl,")\n");
           if((yyvsp[(5) - (10)].sl)){
             sl=addsl(sl,indents[indent]);
             sl=addsl(sl,(yyvsp[(5) - (10)].sl));
           }
           sl=addsl(sl,(yyvsp[(6) - (10)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endcase\n");
           (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
         ;}
    break;

  case 81:
#line 1541 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
           sl=addtxt(sl,"disable;  //VHD2VL: add block name here\n");
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
         ;}
    break;

  case 82:
#line 1547 "vhd2vl.y"
    {
         slist *sl;
           if((yyvsp[(1) - (4)].sl)){
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           }else
             (yyval.sl)=(yyvsp[(4) - (4)].sl);
         ;}
    break;

  case 83:
#line 1557 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 84:
#line 1558 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(indents[indent],"else if(");
             sl=addsl(sl,(yyvsp[(2) - (7)].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(5) - (7)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n");
             (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
           ;}
    break;

  case 85:
#line 1568 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(indents[indent],"else begin\n");
             sl=addsl(sl,(yyvsp[(3) - (4)].sl));
             sl=addsl(sl,indents[indent]);
             (yyval.sl)=addtxt(sl,"end\n");
           ;}
    break;

  case 86:
#line 1577 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl(indents[indent],(yyvsp[(2) - (8)].sl));
          sl=addtxt(sl," : begin\n");
          sl=addsl(sl,(yyvsp[(6) - (8)].sl));
          sl=addsl(sl,indents[indent]);
          sl=addtxt(sl,"end\n");
          (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
        ;}
    break;

  case 87:
#line 1586 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt(indents[indent],"default : begin\n");
          sl=addsl(sl,(yyvsp[(6) - (7)].sl));
          sl=addsl(sl,indents[indent]);
          (yyval.sl)=addtxt(sl,"end\n");
        ;}
    break;

  case 88:
#line 1595 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 89:
#line 1596 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl),",");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 90:
#line 1603 "vhd2vl.y"
    {(yyval.sl)=addvec(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 91:
#line 1604 "vhd2vl.y"
    {(yyval.sl)=addtxt(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 92:
#line 1607 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].ss)->sl; free((yyvsp[(1) - (1)].ss));;}
    break;

  case 93:
#line 1608 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt((yyvsp[(1) - (3)].ss)->sl," or ");
              free((yyvsp[(1) - (3)].ss));
              (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
            ;}
    break;

  case 94:
#line 1616 "vhd2vl.y"
    {
           slist *sl;
             if(delay && (yyvsp[(2) - (3)].n)){
               sl=addtxt(NULL,"# ");
               sl=addval(sl,(yyvsp[(2) - (3)].n));
               sl=addtxt(sl," ");
             } else
               sl=NULL;
             if((yyvsp[(1) - (3)].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[(1) - (3)].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[(1) - (3)].e)->sl);
             free((yyvsp[(1) - (3)].e));
             delay=1;
             (yyval.sl)=sl;
           ;}
    break;

  case 95:
#line 1632 "vhd2vl.y"
    {
             fprintf(stderr,"Warning on line %d :\nCan't translate expr delay WHEN exprc';' expressions\n",lineno);
             (yyval.sl)=NULL;
           ;}
    break;

  case 96:
#line 1636 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt((yyvsp[(4) - (7)].sl)," ? ");
             if((yyvsp[(1) - (7)].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[(1) - (7)].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[(1) - (7)].e)->sl);
             free((yyvsp[(1) - (7)].e));
             sl=addtxt(sl," : ");
             (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
           ;}
    break;

  case 97:
#line 1649 "vhd2vl.y"
    {delay=0;;}
    break;

  case 98:
#line 1652 "vhd2vl.y"
    {(yyval.n)=0;;}
    break;

  case 99:
#line 1653 "vhd2vl.y"
    {(yyval.n)=(yyvsp[(2) - (3)].n);;}
    break;

  case 100:
#line 1656 "vhd2vl.y"
    {
           slist *sl;
           sl=addsl((yyvsp[(1) - (2)].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 101:
#line 1660 "vhd2vl.y"
    {
           slist *sl;
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[(2) - (4)].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           ;}
    break;

  case 102:
#line 1669 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].ss)->sl; free((yyvsp[(1) - (1)].ss));;}
    break;

  case 103:
#line 1670 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[(1) - (4)].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[(4) - (4)].ss)->sl);
             free((yyvsp[(4) - (4)].ss));
             (yyval.sl)=addtxt(sl,")");
           ;}
    break;

  case 104:
#line 1681 "vhd2vl.y"
    {
           slist *sl;
           sl=addsl((yyvsp[(1) - (2)].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 105:
#line 1685 "vhd2vl.y"
    {
           slist *sl;
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[(2) - (4)].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           ;}
    break;

  case 106:
#line 1694 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[(1) - (4)].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
             (yyval.sl)=addtxt(sl,")");
           ;}
    break;

  case 107:
#line 1704 "vhd2vl.y"
    {
         slist *sl;
         slval *ss;
           ss=(slval *) malloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[(1) - (1)].txt));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->val=-1;
           ss->range=NULL;
           (yyval.ss)=ss;
         ;}
    break;

  case 108:
#line 1718 "vhd2vl.y"
    {
         slval *ss;
         slist *sl;
           ss=(slval *) malloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[(1) - (4)].txt));
           sl=addpar(sl,(yyvsp[(3) - (4)].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[(3) - (4)].v);
           if((yyvsp[(3) - (4)].v)->vtype==tSCALAR) {
             ss->val=1;
           } else {
             ss->val = -1; /* width is in the vrange */
           }
           (yyval.ss)=ss;
         ;}
    break;

  case 109:
#line 1740 "vhd2vl.y"
    {
         expdata *e;
           e=(expdata *) malloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=(yyvsp[(1) - (1)].ss)->sl;
           free((yyvsp[(1) - (1)].ss));
           (yyval.e)=e;
         ;}
    break;

  case 110:
#line 1748 "vhd2vl.y"
    {
         expdata *e;
           e=(expdata *) malloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec(NULL,(yyvsp[(1) - (1)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 111:
#line 1755 "vhd2vl.y"
    {
         expdata *e;
         char *natval = (char *) malloc(99*sizeof(char));
           e=(expdata *) malloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           sprintf(natval, "%d",(yyvsp[(1) - (1)].n));
           e->sl=addtxt(NULL,natval);
           (yyval.e)=e;
         ;}
    break;

  case 112:
#line 1764 "vhd2vl.y"
    {  /* e.g. 16#55aa# */
         expdata *e;
         char *natval = (char *) malloc(99*sizeof(char));
           e=(expdata *) malloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           switch((yyvsp[(1) - (2)].n)) {
           case  2:
             sprintf(natval, "'B%s",(yyvsp[(2) - (2)].txt));
             break;
           case  8:
             sprintf(natval, "'O%s",(yyvsp[(2) - (2)].txt));
             break;
           case 10:
             sprintf(natval, "'D%s",(yyvsp[(2) - (2)].txt));
             break;
           case 16:
             sprintf(natval, "'H%s",(yyvsp[(2) - (2)].txt));
             break;
           default:
             sprintf(natval,"%d#%s#",(yyvsp[(1) - (2)].n),(yyvsp[(2) - (2)].txt));
             fprintf(stderr,"Warning on line %d :Can't translate based number %s (bases of 2,8,10 and 16 are translateable)\n",lineno,natval);
           }
           e->sl=addtxt(NULL,natval);
           (yyval.e)=e;
         ;}
    break;

  case 113:
#line 1789 "vhd2vl.y"
    {
         expdata *e;
           e=(expdata *) malloc(sizeof(expdata));
           e->op='o'; /* others */
           e->sl=addothers(NULL,(yyvsp[(5) - (6)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 114:
#line 1796 "vhd2vl.y"
    { /* Vector chaining */
         slist *sl;
           sl=addtxt((yyvsp[(1) - (3)].e)->sl,",");
           sl=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
           free((yyvsp[(3) - (3)].e));
           (yyvsp[(1) - (3)].e)->op='c';
           (yyvsp[(1) - (3)].e)->sl=sl;
           (yyval.e)=(yyvsp[(1) - (3)].e);
         ;}
    break;

  case 115:
#line 1805 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'m'," -",(yyvsp[(2) - (2)].e));;}
    break;

  case 116:
#line 1806 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'p'," +",(yyvsp[(2) - (2)].e));;}
    break;

  case 117:
#line 1807 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'+'," + ",(yyvsp[(3) - (3)].e));;}
    break;

  case 118:
#line 1808 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'-'," - ",(yyvsp[(3) - (3)].e));;}
    break;

  case 119:
#line 1809 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'*'," * ",(yyvsp[(3) - (3)].e));;}
    break;

  case 120:
#line 1810 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'/'," / ",(yyvsp[(3) - (3)].e));;}
    break;

  case 121:
#line 1811 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'%'," % ",(yyvsp[(3) - (3)].e));;}
    break;

  case 122:
#line 1812 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'~'," ~",(yyvsp[(2) - (2)].e));;}
    break;

  case 123:
#line 1813 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'&'," & ",(yyvsp[(3) - (3)].e));;}
    break;

  case 124:
#line 1814 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'|'," | ",(yyvsp[(3) - (3)].e));;}
    break;

  case 125:
#line 1815 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'^'," ^ ",(yyvsp[(3) - (3)].e));;}
    break;

  case 126:
#line 1816 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'~'," ~",addexpr((yyvsp[(1) - (3)].e),'^'," ^ ",(yyvsp[(3) - (3)].e)));;}
    break;

  case 127:
#line 1817 "vhd2vl.y"
    {
       /* single argument type conversion function e.g. std_ulogic_vector(x) */
       expdata *e;
       e=(expdata *) malloc(sizeof(expdata));
       if ((yyvsp[(3) - (4)].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[(3) - (4)].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[(3) - (4)].e)->sl,")"); 
       }
       (yyval.e)=e;
      ;}
    break;

  case 128:
#line 1828 "vhd2vl.y"
    {
       /* two argument type conversion e.g. to_unsigned(x, 3) */
       expdata *e;
       e=(expdata *) malloc(sizeof(expdata));
       if ((yyvsp[(3) - (6)].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[(3) - (6)].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[(3) - (6)].e)->sl,")"); 
       }
       (yyval.e)=e;
      ;}
    break;

  case 129:
#line 1839 "vhd2vl.y"
    {
       expdata *e;
       e=(expdata *) malloc(sizeof(expdata));
       if ((yyvsp[(3) - (6)].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[(3) - (6)].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[(3) - (6)].e)->sl,")"); 
       }
       (yyval.e)=e;
      ;}
    break;

  case 130:
#line 1849 "vhd2vl.y"
    {
       expdata *e;
       e=(expdata *) malloc(sizeof(expdata));
       if ((yyvsp[(2) - (3)].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[(2) - (3)].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[(2) - (3)].e)->sl,")"); 
       }
       (yyval.e)=e;
      ;}
    break;

  case 131:
#line 1862 "vhd2vl.y"
    { (yyval.sl)=(yyvsp[(1) - (1)].sl); ;}
    break;

  case 132:
#line 1863 "vhd2vl.y"
    {
         (yyval.sl)=addwrap("(",(yyvsp[(2) - (3)].sl),")");
      ;}
    break;

  case 133:
#line 1866 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl)," && ");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 134:
#line 1871 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl)," || ");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 135:
#line 1876 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt(NULL,"!");
          (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));
        ;}
    break;

  case 136:
#line 1884 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} == ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") == ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," == ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 137:
#line 1901 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} > ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") > ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," > ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 138:
#line 1918 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} >= ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") >= ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," >= ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 139:
#line 1935 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} < ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") < ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," < ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 140:
#line 1952 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} <= ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") <= ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," <= ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 141:
#line 1969 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} != ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") != ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," != ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 142:
#line 1988 "vhd2vl.y"
    {
         expdata *e;
         e=(expdata *) malloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=(yyvsp[(1) - (1)].ss)->sl;
         free((yyvsp[(1) - (1)].ss));
         (yyval.e)=e;
      ;}
    break;

  case 143:
#line 1996 "vhd2vl.y"
    {
         expdata *e;
         e=(expdata *) malloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=addvec(NULL,(yyvsp[(1) - (1)].txt));
         (yyval.e)=e;
      ;}
    break;

  case 144:
#line 2003 "vhd2vl.y"
    {
         expdata *e;
         e=(expdata *) malloc(sizeof(expdata));
         char *natval = (char *) malloc(99*sizeof(char));
         e->op='n'; /* natural */
         e->value=(yyvsp[(1) - (1)].n);
         sprintf(natval, "%d",(yyvsp[(1) - (1)].n));
         e->sl=addtxt(NULL,natval);
         (yyval.e)=e;
      ;}
    break;

  case 145:
#line 2013 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'+'," + ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 146:
#line 2016 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'-'," - ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 147:
#line 2019 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'*'," * ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 148:
#line 2022 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'/'," / ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 149:
#line 2025 "vhd2vl.y"
    {
       expdata *e;
       e=(expdata *) malloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[(2) - (3)].e)->sl,")"); 
       (yyval.e)=e;
      ;}
    break;


/* Line 1267 of yacc.c.  */
#line 4372 "vhd2vl.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 2033 "vhd2vl.y"


char *outfile;    /* Output file */
char *sourcefile; /* Input file */

int main(int argc, char *argv[]){
int i,j;
char *s;
slist *sl;
int status; 

  if (strcmp(argv[1], "-d") == 0) {
    yydebug = 1;
    sourcefile = argv[2];
    outfile = argv[3];
  } else {
    yydebug = 0; /* set this to 1 to trace parsing */
    sourcefile = argv[1];
    outfile = argv[2];
  }

  if (!freopen(sourcefile, "r", stdin)) {
     fprintf(stderr, "Error: Can't open input file '%s'\n", sourcefile);
     return(1);
     }

  if (!freopen(outfile, "w", stdout)) {
     fprintf(stderr, "Error: Can't open output file '%s'\n", outfile);
     fclose(stdin);
     return(1);
     }

  fprintf(stderr, "// File %s translated with vhd2vl v2.0 VHDL to Verilog RTL translator\n", sourcefile);
  printf("// File %s translated with vhd2vl v2.0 VHDL to Verilog RTL translator\n", sourcefile);
  printf("// Copyright (C) 2001 Vincenzo Liguori - Ocean Logic Pty Ltd - http://www.ocean-logic.com\n");
  printf("// Modifications (C) 2006 Mark Gonzales - PMC Sierra Inc\n");
  printf("// \n");
  printf("// vhd2vl comes with ABSOLUTELY NO WARRANTY\n");
  printf("// ALWAYS RUN A FORMAL VERIFICATION TOOL TO COMPARE VHDL INPUT TO VERILOG OUTPUT \n");
  printf("// \n");
  printf("// This is free software, and you are welcome to redistribute it under certain conditions.\n");
  printf("// See the license file license.txt included with the source for details.\n\n");

  /* Init the indentation variables */
  indents[0]=NULL;
  for(i=1;i<MAXINDENT;i++){
    indents[i]=sl=(slist *) malloc(sizeof(slist));
    sl->data.txt=s=(char *) malloc(sizeof(char) *((i<<1)+1));
    for(j=0;j<(i<<1);j++)
      *s++=' ';
    *s=0;
    sl->type=1;
    sl->slst=NULL;
  }

  status = yyparse();
  fclose(stdout);
  fclose(stdin);
  exit(status);
}


